import { PanelDetailModel } from './panel-detail';
import { PanelTabPanelModel } from './panel-tab-panel';

/**
 * 分页面板模型
 *
 * @export
 * @class PanelTabPageModel
 * @extends {PanelDetailModel}
 */
export class PanelTabPageModel extends PanelDetailModel {

    /**
     * 子项
     *
     * @type {string[]}
     * @memberof PanelTabPageModel
     */
    public details: string[] = [];

    /**
     * Creates an instance of PanelTabPageModel.
     * PanelTabPageModel 实例
     * 
     * @param {*} [opts={}]
     * @memberof PanelTabPageModel
     */
    constructor(opts: any = {}) {
        super(opts);
        this.details = opts.details;
    }

    /**
     * 加载
     *
     * @param {*} context
     * @param {*} viewParams
     * @memberof PanelTabPageModel
     */
    public async load(context: any, viewParams: any) {
        if (!this.parentName) {
            if (this.type == 'VIEWLAYOUT') {
                this.data = {};
            } else {
                this.data = this.panel.data;
            }
        } else {
            let parentItem = this.panel.layoutModelDetails[`${this.parentName}_${this.index}`];
            if (!parentItem) {
                parentItem = this.panel.layoutModelDetails[this.parentName];
            }
            if (parentItem) {
                if (parentItem.dataRegionType === 'MULTIDATA' && parentItem['data'] && parentItem['data'].length > 0) {
                    this.data = parentItem.getData()[this.getIndex()];    
                } else {
                    this.data = parentItem.getData();
                }
            }
        }
    }
}